import o from"path";import{URL as r}from"url";import e from"yargs";import{hideBin as t}from"yargs/helpers";import i from"os";import n from"fs";import l from"yamljs";import{execSync as s}from"child_process";const a=/^0x([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/,d=/^#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/;function f(o){return o?o[0].toUpperCase()+o.substring(1).toLowerCase():void 0}function c(o){o=o.trim();if(!/^([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/.test(o))throw new Error("Color code, provided in params, is neither in 3 letter format nor in 6 letter format..");if(3===o.length){let r="";for(let e=0;e<=2;e++)r+=o.charAt(e)+o.charAt(e);return r}return o}function u(o){if("string"==typeof o){if(!o||o&&""===o.trim())return;if(o=o.trim(),a.test(o))return"#"+c(o.substring(2));if(d.test(o))return"#"+c(o.substring(1));throw new Error("Color code is not provided in hex(0x) or hash(#) format..")}if("number"==typeof o){return"#"+c(o.toString(16))}}function v(o){if("string"==typeof o){if(!o||o&&""===o.trim())return;if(o=o.trim(),d.test(o))return"0x"+c(o.substring(1));if(a.test(o))return"0x"+c(o.substring(2));throw new Error("Color code is not provided in hex(0x) or hash(#) format..")}if("number"==typeof o){return"0x"+c(o.toString(16))}}function y(o={}){var r,i,n,l,s,a,d,c,u,y,m,p,h,g;const b="fontsize",w="bgcolor",k="fgcolor",x="selcolor",$="cursor",_="opacity",A=16,E="#111122",F="#ccccff",P="#111122",z="Block",B=1;return e(t(process.argv)).usage("Usage: node dist/$0 [options]=[values]\n\nThe options may/may not provided in the CLI. If they are not provided, either the previously set config is used or the defaults are set.").help("h").version("1.1.1").alias("s",b).alias("b",w).alias("c",k).alias("t",x).alias("y",$).alias("o",_).alias("h","help").alias("v","version").default(b,null!==(i=null===(r=null==o?void 0:o.font)||void 0===r?void 0:r.size)&&void 0!==i?i:A).default(w,null!==(s=null===(l=null===(n=null==o?void 0:o.colors)||void 0===n?void 0:n.primary)||void 0===l?void 0:l.background)&&void 0!==s?s:E).default(k,null!==(c=null===(d=null===(a=null==o?void 0:o.colors)||void 0===a?void 0:a.primary)||void 0===d?void 0:d.foreground)&&void 0!==c?c:F).default(x,null!==(m=null===(y=null===(u=null==o?void 0:o.colors)||void 0===u?void 0:u.selection)||void 0===y?void 0:y.text)&&void 0!==m?m:P).default($,null!==(h=null===(p=null==o?void 0:o.cursor)||void 0===p?void 0:p.style)&&void 0!==h?h:z).default(_,null!==(g=null==o?void 0:o.background_opacity)&&void 0!==g?g:B).nargs({[b]:1,[w]:1,[k]:1,[x]:1,[$]:1,[_]:1}).describe(b,`Takes font size to be set in alacritty\t[default=${A}]`).describe(w,`Takes primary background color in #ffffff or #fff or 0xfff or 0xffffff format\t[default=${E}]`).describe(k,`Takes primary foreground color in #ffffff or #fff or 0xfff or 0xffffff format\t[default=${F}]`).describe(x,`Takes text color (when the area is selected) in #ffffff or #fff or 0xfff or 0xffffff format\t[default=${P}]`).describe($,`Takes cursor style that can be Block or Underline or Beam\t[default=${z}]`).describe(_,`Takes background opacity which is between 0.0 (transparent) and 1.0 (opaque)\t[default=${B}]`).check((o=>{if(o.s&&(o.s<=0||o.s>40))throw new Error(`Wrong Arguments: Provided font size ${o.s} should be within the range of display: 0.1 to 40.0`);if(o.b&&void 0===v(o.b))throw new Error(`Wrong Arguments: Provided background color ${o.b} should be in hash or hex format`);if(o.c&&void 0===v(o.c))throw new Error(`Wrong Arguments: Provided font color ${o.c} should be in hash or hex format`);if(o.t&&void 0===v(o.t))throw new Error(`Wrong Arguments: Provided selection text color ${o.t} should be in hash or hex format`);if(o.y&&!["Block","Underline","Beam"].includes(f(""+o.y)))throw new Error(`Wrong Arguments: Provided cursor style ${o.y} should be in one of the 3 styles`);if(o.o&&(o.o<0||o.o>1))throw new Error(`Wrong Arguments: Provided background opacity ${o.o} should be between 0.0 and 1.0`);return!0})).argv}function m(){if("Windows_NT"===i.type())throw new Error("Platform win32 not supported by our app");try{s("which alacritty")}catch(o){throw new Error("Package Not Installed: alacritty is not installed in your system or it's path is not set in your PATH variable, so you cannot use our library..")}const r=o.join(i.homedir(),".config/alacritty/alacritty.yml");return n.existsSync(r)||(n.mkdirSync(o.dirname(r),{recursive:!0}),n.writeFileSync(r,"")),r}function p(o){try{return l.load(o)}catch(o){throw new Error("Cannot load original alacritty config file from the path provided..")}}function h(r,e){const t=o.join(e,"user_config_temp"),i=o.resolve(t,"alacritty.json");n.mkdirSync(t,{recursive:!0}),n.writeFileSync(i,JSON.stringify(r),"utf8");const l=`npx json2yaml '${i}' --save -d 8 && mv '${o.resolve(t,"alacritty.yaml")}' '${o.resolve(t,"alacritty.yml")}' && cp '${o.resolve(t,"alacritty.yml")}' '${e}' && rm -rf ${t}`;s(l),console.log("Please close and reopen all windows of alacritty if some effects were not applied..")}function g(o={},r,e){var t,i,n,l,s,a,d,c,u,y,m,p,g,b;let w=null!==(n=null===(i=null===(t=null==o?void 0:o.colors)||void 0===t?void 0:t.primary)||void 0===i?void 0:i.background)&&void 0!==n?n:"",k=null!==(a=null===(s=null===(l=null==o?void 0:o.colors)||void 0===l?void 0:l.primary)||void 0===s?void 0:s.foreground)&&void 0!==a?a:"",x=null!==(c=null===(d=null==o?void 0:o.font)||void 0===d?void 0:d.size)&&void 0!==c?c:void 0,$=null!==(m=null===(y=null===(u=null==o?void 0:o.colors)||void 0===u?void 0:u.selection)||void 0===y?void 0:y.text)&&void 0!==m?m:"",_=null!==(g=null===(p=null==o?void 0:o.cursor)||void 0===p?void 0:p.style)&&void 0!==g?g:"Block",A=null!==(b=null==o?void 0:o.background_opacity)&&void 0!==b?b:void 0,{primary_bgcolor:E=w,primary_fgcolor:F=k,fontsize:P=x,selection_fgcolor:z=$,cursor_style:B=_,background_opacity:S=A}=r;if(E=v(E),F=v(F),z=v(z),P<.1||P>40)throw new Error("Font size provided is not in the range 0.1 to 40.0");if(B&&!["Block","Underline","Beam"].includes(f(B)))throw new Error("Cursor style provided is not in one of the 3 accepted styles");if(S<0||S>1)throw new Error("Background opacity provided is not in the range 0.0 to 1.0");const T=Object.assign(Object.assign({},o),{font:{size:P},colors:{primary:{background:E,foreground:F},selection:{text:z}},cursor:{style:B},background_opacity:S});return h(T,e),T}var b;const w=new r(`file://${process.argv[1]}`);(null===(b=import.meta)||void 0===b?void 0:b.url)===w.toString()&&function(){let r="";try{r=m();let e=p(r);const t=o.dirname(r);let i=y(e);g(e,{fontsize:parseFloat(""+i.s),primary_bgcolor:i.b,primary_fgcolor:i.c,selection_fgcolor:i.t,cursor_style:i.y,background_opacity:parseFloat(""+i.o)},t)}catch(o){console.error(o)}}();export{f as capitaliseString,m as configInit,c as convertShortToLongCode,u as convertToHash,v as convertToHex,g as editConfig,d as hash_color_regex,a as hex_color_regex,p as readOriginalConfig,y as takeArgumentInputs,h as writeToConfigFile};
